SystemOrganization addCategory: #'Artefact-Examples'!
SystemOrganization addCategory: 'Artefact-Examples-Demos'!
SystemOrganization addCategory: 'Artefact-Examples-Demos-Templates'!
SystemOrganization addCategory: 'Artefact-Examples-Tutorial'!

PDFComposite subclass: #PDFClockElement
	instanceVariableNames: 'time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Examples-Tutorial'!

!PDFClockElement commentStamp: '<historical>' prior: 0!
A PDFClockElement is a basic tutorial element about how to create composite.

Instance Variables
	time:		<Object>

time
	- xxxxx
!

!PDFClockElement class methodsFor: 'steps' stamp: 'GuillaumeLarcheveque 6/28/2013 11:21'!
clockTutorialStep1
	"PDFClockElement clockTutorialStep1"

	| doc |
	doc := PDFDocument new.
		doc add: (PDFPage new add: ((PDFClockElement from: 2 cm @ 2 cm to: 10 cm @ 10 cm) time: Time current)).
		doc exportTo: 'clockTutorialStep1.pdf' asFileReference writeStream! !

!PDFClockElement class methodsFor: 'steps' stamp: 'GuillaumeLarcheveque 6/28/2013 11:28'!
clockTutorialStep2
	"PDFClockElement clockTutorialStep2"

	| doc |
	doc := PDFDocument new.
		doc add: (PDFPage new add: ((PDFClockElement from: 2 cm @ 2 cm to: 10 cm @ 10 cm) time: Time current)).
		doc styleSheet > #clock drawColor: (PDFColor r:180 g: 24 b:24); fillColor: (PDFColor r:230 g: 230 b:10).
		doc exportTo: 'clockTutorialStep2.pdf' asFileReference writeStream! !

!PDFClockElement class methodsFor: 'steps' stamp: 'GuillaumeLarcheveque 6/28/2013 11:33'!
clockTutorialStep3
	"PDFClockElement clockTutorialStep3"

	| doc |
	doc := PDFDocument new.
		doc add: (PDFPage new add: ((PDFClockElement from: 2 cm @ 2 cm to: 10 cm @ 10 cm) time: Time current)).
		doc styleSheet > #clock drawColor: (PDFColor r:180 g: 24 b:24); fillColor: (PDFColor r:230 g: 230 b:10).
		doc styleSheet > #clock > #arrow drawColor: (PDFColor r:0 g: 45 b:200).
		doc exportTo: 'clockTutorialStep3.pdf' asFileReference writeStream! !

!PDFClockElement class methodsFor: 'steps' stamp: 'GuillaumeLarcheveque 6/28/2013 11:44'!
clockTutorialStep4
	"PDFClockElement clockTutorialStep4"

	| doc |
	doc := PDFDocument new.
		doc add: (PDFPage new add: ((PDFClockElement from: 2 cm @ 2 cm to: 10 cm @ 10 cm) time: Time current)).
		doc styleSheet > #clock drawColor: (PDFColor r:180 g: 24 b:24); fillColor: (PDFColor r:230 g: 230 b:10).
		doc styleSheet > #clock > #hourHand drawColor: (PDFColor r:0 g: 45 b:200).
		doc styleSheet > #clock > #minuteHand drawColor: (PDFColor r:0 g: 200 b:45).
		doc exportTo: 'clockTutorialStep4.pdf' asFileReference writeStream! !

!PDFClockElement class methodsFor: 'steps' stamp: 'GuillaumeLarcheveque 6/28/2013 13:16'!
clockTutorialStep5
	"PDFClockElement clockTutorialStep5"

	| doc |
	doc := PDFDocument new.
		doc add: (PDFPage new add: ((PDFClockElement from: 2 cm @ 2 cm to: 10 cm @ 10 cm) time: Time current);
			 add: ((PDFClockElement from: 12 cm @ 2 cm to: 20 cm @ 10 cm) time: Time current; style: #apocalypseClock)).
		doc styleSheet > #clock drawColor: (PDFColor r:180 g: 24 b:24); fillColor: (PDFColor r:230 g: 230 b:10).
		doc styleSheet > #clock > #hourHand drawColor: (PDFColor r:0 g: 45 b:200).
		doc styleSheet > #clock > #minuteHand drawColor: (PDFColor r:0 g: 200 b:45).
		doc styleSheet > #apocalypseClock fillColor: (PDFColor r:244 g: 221 b:25); thickness: 2mm; roundCap: true.
		doc styleSheet > #apocalypseClock > #minuteHand drawColor: (PDFColor r:240 g: 6 b: 7); thickness: 1 mm.
		doc exportTo: 'clockTutorialStep5.pdf' asFileReference writeStream! !

!PDFClockElement methodsFor: 'style' stamp: 'GuillaumeLarcheveque 6/21/2013 14:31'!
defaultStyle
	^ #clock! !

!PDFClockElement methodsFor: 'render' stamp: 'GuillaumeLarcheveque 6/28/2013 11:45'!
getSubElementsWith: aGenerator styleSheet: aStyleSheet
	| hourAngle minuteAngle |
	hourAngle := Float pi / 2 - (time hour12 * 2 * Float pi / 12).
	minuteAngle := Float pi / 2 - (time minute * 2 * Float pi / 60).
	^ {(PDFCircleElement from: self from to: self to).
	(PDFCircleElement center: self center radius: self dimension min * 0.05).
	((PDFArrowElement from: self center angle: hourAngle length: dimension min * 0.25) style: #hourHand).
	((PDFArrowElement from: self center angle: minuteAngle length: dimension min * 0.45) style: #minuteHand)}! !

!PDFClockElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 6/21/2013 14:11'!
time
	^ time! !

!PDFClockElement methodsFor: 'accessing' stamp: 'GuillaumeLarcheveque 6/21/2013 14:11'!
time: anObject
	time := anObject! !

PDFTemplate subclass: #PDFCompactDiscTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Examples-Demos-Templates'!

!PDFCompactDiscTemplate commentStamp: '<historical>' prior: 0!
A cover for compact disc
!

!PDFCompactDiscTemplate class methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/25/2013 14:00'!
recommendedPageFormat
	^(PDFA4Format new setLandscape)! !

!PDFCompactDiscTemplate methodsFor: 'action' stamp: 'GuillaumeLarcheveque 5/24/2013 14:11'!
drawTemplate
	self add: ((PDFRectElement 
		from: 10 mm @ 10 mm
		dimension: 240 mm @ 120 mm)
		dotted: self dotted
	).
	self add: ((PDFLineElement  
		from: 130mm @ 10mm
		to: 130mm @ 130mm)
		dotted: self dotted
	).! !

PDFTemplate subclass: #PDFDVDCoverTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Examples-Demos-Templates'!

!PDFDVDCoverTemplate commentStamp: '<historical>' prior: 0!
A cover for DVD
!

!PDFDVDCoverTemplate class methodsFor: 'accessing' stamp: 'OlivierAuverlot 4/25/2013 14:00'!
recommendedPageFormat
	^(PDFA4Format new setLandscape)! !

!PDFDVDCoverTemplate methodsFor: 'action' stamp: 'GuillaumeLarcheveque 5/24/2013 14:10'!
drawTemplate
	self add: ((PDFRectElement 
		from: 10 mm @ 10 mm
		dimension: 272 mm @ 182 mm)
		dotted: self dotted
	).
	self add: ((PDFLineElement  
		from:139mm @ 10mm
		to: 139mm @ 192mm)
		dotted: self dotted
	).
	self add: ((PDFLineElement  
		from:153mm @ 10mm
		to: 153mm @ 192mm)
		dotted: self dotted
	).! !

Object subclass: #PDFDemos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Examples-Demos'!

!PDFDemos commentStamp: '<historical>' prior: 0!
A PDFDemos is the class containing all demos for Artefact framework. By default each generation result is written in the default pharo directory but you can define your own in the demoPath method 

example: 

demoPath
	^ '/Users/pharo/pdf/'

Instance Variables
!

!PDFDemos class methodsFor: 'templates' stamp: 'CyrilFerlicot 5/31/2016 13:04'!
CDTemplateTest
	"PDFDemos CDTemplateTest"

	<script>
	self new CDTemplateTest: (self streamNamed: 'CDTemplateTest.pdf')! !

!PDFDemos class methodsFor: 'templates' stamp: 'CyrilFerlicot 5/31/2016 13:04'!
DVDTemplateTest
	"PDFDemos DVDTemplateTest"

	<script>
	self new DVDTemplateTest: (self streamNamed: 'DVDTemplateTest.pdf')! !

!PDFDemos class methodsFor: 'text' stamp: 'CyrilFerlicot 5/31/2016 13:04'!
alignmentsTest
	"PDFDemos alignmentsTest"

	<script>
	self new alignmentsTest: (self streamNamed: 'alignmentsTest.pdf')! !

!PDFDemos class methodsFor: 'composite' stamp: 'CyrilFerlicot 5/31/2016 13:04'!
arrowTest
	"PDFDemos arrowTest"

	<script>
	self new arrowTest: (self streamNamed: 'arrowTest.pdf')! !

!PDFDemos class methodsFor: 'draw' stamp: 'CyrilFerlicot 5/31/2016 13:04'!
bezierTest
	"PDFDemos bezierTest"

	<script>
	self new bezierTest: (self streamNamed: 'bezierTest.pdf')! !

!PDFDemos class methodsFor: 'experimental' stamp: 'CyrilFerlicot 5/31/2016 13:04'!
brochureTest
	"PDFDemos brochureTest"

	<script>
	self new brochure: (self streamNamed: 'brochure.pdf')! !

!PDFDemos class methodsFor: 'draw' stamp: 'CyrilFerlicot 5/31/2016 13:04'!
capLineTest
	"PDFDemos capLineTest"

	<script>
	self new capLineTest: (self streamNamed: 'capLineTest.pdf')! !

!PDFDemos class methodsFor: 'composite' stamp: 'CyrilFerlicot 5/31/2016 13:04'!
cellTest
	"PDFDemos cellTest"

	<script>
	self new cellTest: (self streamNamed: 'cellTest.pdf')! !

!PDFDemos class methodsFor: 'draw' stamp: 'CyrilFerlicot 5/31/2016 13:04'!
circlesTest
	"PDFDemos circlesTest"

	<script>
	self new circlesTest: (self streamNamed: 'circlesTest.pdf')! !

!PDFDemos class methodsFor: 'color' stamp: 'CyrilFerlicot 5/31/2016 13:05'!
colorTest
	"PDFDemos colorTest"

	<script>
	self new colorTest: (self streamNamed: 'colorTest.pdf')! !

!PDFDemos class methodsFor: 'composite' stamp: 'CyrilFerlicot 5/31/2016 13:05'!
datatableTest
	"PDFDemos datatableTest"

	<script>
	self new datatableTest: (self streamNamed: 'datatableTest.pdf')! !

!PDFDemos class methodsFor: 'composite' stamp: 'CyrilFerlicot 5/31/2016 13:05'!
datatableWithCaptionsTest
	"PDFDemos datatableWithCaptionsTest"

	<script>
	self new datatableWithCaptionsTest: (self streamNamed: 'datatableWithCaptionsTest.pdf')! !

!PDFDemos class methodsFor: 'tool' stamp: 'GuillaumeLarcheveque 5/31/2013 10:19'!
demoPath
	^ 'pdf/'
! !

!PDFDemos class methodsFor: 'display setup' stamp: 'CyrilFerlicot 5/31/2016 13:05'!
documentDisplayLayoutTest
	"PDFDemos documentDisplayLayoutTest"

	<script>
	self new documentDisplayLayoutTest: (self streamNamed: 'documentDisplayLayoutTest.pdf')! !

!PDFDemos class methodsFor: 'display setup' stamp: 'CyrilFerlicot 5/31/2016 13:05'!
documentDisplayModeTest
	"PDFDemos documentDisplayModeTest"

	<script>
	self new documentDisplayModeTest: (self streamNamed: 'documentDisplayModeTest.pdf')! !

!PDFDemos class methodsFor: 'display setup' stamp: 'CyrilFerlicot 5/31/2016 13:05'!
documentZoomTest
	"PDFDemos documentZoomTest"

	<script>
	self new documentZoomTest: (self streamNamed: 'documentZoomTest.pdf')! !

!PDFDemos class methodsFor: 'color' stamp: 'CyrilFerlicot 5/31/2016 13:05'!
drawStyleSheetTest
	"PDFDemos drawStyleSheetTest"

	<script>
	self new drawStyleSheetTest: (self streamNamed: 'drawStyleSheetTest.pdf')! !

!PDFDemos class methodsFor: 'draw' stamp: 'CyrilFerlicot 5/31/2016 13:05'!
ellipsesTest
	"PDFDemos ellipsesTest"

	<script>
	self new ellipsesTest: (self streamNamed: 'ellipsesTest.pdf')! !

!PDFDemos class methodsFor: 'text' stamp: 'CyrilFerlicot 5/31/2016 13:05'!
euroTest
	"PDFDemos euroTest"

	<script>
	self new euroTest: (self streamNamed: 'euroTest.pdf')! !

!PDFDemos class methodsFor: 'color' stamp: 'CyrilFerlicot 5/31/2016 13:05'!
greyLevelTest
	"PDFDemos greyLevelTest"

	<script>
	self new greyLevelTest: (self streamNamed: 'greyLevelTest.pdf')! !

!PDFDemos class methodsFor: 'layout' stamp: 'CyrilFerlicot 5/31/2016 13:05'!
horizontalLayoutTest
	"PDFDemos horizontalLayoutTest"

	<script>
	self new horizontalLayoutTest: (self streamNamed: 'horizontalLayoutTest.pdf')! !

!PDFDemos class methodsFor: 'image' stamp: 'CyrilFerlicot 5/31/2016 13:05'!
imageJPG
	"PDFDemos imageJPG"

	<script>
	self new imageJPG: (self streamNamed: 'imageJPG.pdf')! !

!PDFDemos class methodsFor: 'image' stamp: 'CyrilFerlicot 5/31/2016 13:05'!
imagePNG
	"PDFDemos imagePNG"

	<script>
	self new imagePNG: (self streamNamed: 'imagePNG.pdf')! !

!PDFDemos class methodsFor: 'document' stamp: 'CyrilFerlicot 5/31/2016 13:06'!
infosTest
	"PDFDemos infosTest"

	<script>
	self new infosTest: (self streamNamed: 'infosTest.pdf')! !

!PDFDemos class methodsFor: 'draw' stamp: 'CyrilFerlicot 5/31/2016 13:06'!
lineTest
	"PDFDemos lineTest"

	<script>
	self new lineTest: (self streamNamed: 'lineTest.pdf')! !

!PDFDemos class methodsFor: 'color' stamp: 'CyrilFerlicot 5/31/2016 13:06'!
mosaiqueTest
	"PDFDemos mosaiqueTest"

	<script>
	self new mosaiqueTest: (self streamNamed: 'mosaiqueTest.pdf')! !

!PDFDemos class methodsFor: 'document' stamp: 'CyrilFerlicot 5/31/2016 13:06'!
multiOrientationsTest
	"PDFDemos multiOrientationsTest"

	<script>
	self new multiOrientationsTest: (self streamNamed: 'multiOrientationsTest.pdf')! !

!PDFDemos class methodsFor: 'style' stamp: 'CyrilFerlicot 5/31/2016 13:07'!
multiStyleArrowsTest
	"PDFDemos multiStyleArrowsTest"

	<script>
	self new multiStyleArrowsTest: (self streamNamed: 'multiStyleArrowsTest.pdf')! !

!PDFDemos class methodsFor: 'cool' stamp: 'CyrilFerlicot 5/31/2016 13:07'!
oneLineTest
	"PDFDemos oneLineTest"

	<script>
	self new oneLineTest: (self streamNamed: 'oneLineTest.pdf')! !

!PDFDemos class methodsFor: 'composite' stamp: 'CyrilFerlicot 5/31/2016 13:07'!
paragraphTest
	"PDFDemos paragraphTest"

	<script>
	self new paragraphTest: (self streamNamed: 'paragraphTest.pdf')! !

!PDFDemos class methodsFor: 'composite' stamp: 'CyrilFerlicot 5/31/2016 13:07'!
paragraphWithSpacingTest
	"PDFDemos paragraphWithSpacingTest"

	<script>
	self new paragraphWithSpacingTest: (self streamNamed: 'paragraphWithSpacingTest.pdf')! !

!PDFDemos class methodsFor: 'draw' stamp: 'CyrilFerlicot 5/31/2016 13:06'!
polygonsTest
	"PDFDemos polygonsTest"

	<script>
	self new polygonsTest: (self streamNamed: 'polygonsTest.pdf')! !

!PDFDemos class methodsFor: 'draw' stamp: 'CyrilFerlicot 5/31/2016 13:06'!
rectsTest
	"PDFDemos rectsTest"

	<script>
	self new rectsTest: (self streamNamed: 'rectsTest.pdf')! !

!PDFDemos class methodsFor: 'experimental' stamp: 'CyrilFerlicot 5/31/2016 13:06'!
rotationTest
	"PDFDemos rotationTest"

	<script>
	self new rotationTest: (self streamNamed: 'rotation.pdf')! !

!PDFDemos class methodsFor: 'runAllDemos' stamp: 'CyrilFerlicot 5/31/2016 13:06'!
runAllDemos
	"self runAllDemos"

	<script>
	PDFDemos class methods select: [:m | m selector endsWith: 'Test' ] thenDo: [ :m | PDFDemos perform: m selector ]! !

!PDFDemos class methodsFor: 'tool' stamp: 'GuillaumeLarcheveque 5/31/2013 10:21'!
streamNamed: aName
	| path |
	path := self demoPath asFileReference.
	path exists ifFalse: [ path createDirectory ]. 
	^ FileStream fileNamed: self demoPath , aName! !

!PDFDemos class methodsFor: 'text' stamp: 'CyrilFerlicot 5/31/2016 13:06'!
textTest
	"PDFDemos textTest"

	<script>
	self new textTest: (self streamNamed: 'textTest.pdf')! !

!PDFDemos class methodsFor: 'draw' stamp: 'CyrilFerlicot 5/31/2016 13:06'!
thicknessTest
	"PDFDemos thicknessTest"

	<script>
	self new thicknessTest: (self streamNamed: 'thicknessTest.pdf')! !

!PDFDemos class methodsFor: 'draw' stamp: 'CyrilFerlicot 5/31/2016 13:06'!
twoColoredRectsOpacityTest
	"PDFDemos twoColoredRectsOpacityTest"

	<script>
	self new twoColoredRectsOpacityTest: (self streamNamed: 'twoColoredRectsOpacityTest.pdf')! !

!PDFDemos class methodsFor: 'draw' stamp: 'CyrilFerlicot 5/31/2016 13:06'!
twoColoredRectsTest
	"PDFDemos twoColoredRectsTest"

	<script>
	self new twoColoredRectsTest: (self streamNamed: 'twoColoredRectsTest.pdf')! !

!PDFDemos class methodsFor: 'layout' stamp: 'CyrilFerlicot 5/31/2016 13:06'!
verticalLayoutTest
	"PDFDemos verticalLayoutTest"

	<script>
	self new verticalLayoutTest: (self streamNamed: 'verticalLayoutTest.pdf')! !

!PDFDemos class methodsFor: 'misc' stamp: 'CyrilFerlicot 5/31/2016 13:06'!
widthTest
	"PDFDemos widthTest"

	<script>
	self new widthTest: (self streamNamed: 'widthTest.pdf')! !

!PDFDemos methodsFor: 'templates' stamp: 'AntoanHristov 2/17/2017 16:44'!
CDTemplateTest: aStream
	self CDTemplateTestPdfDocument exportTo: aStream! !

!PDFDemos methodsFor: 'templates' stamp: 'AntoanHristov 2/17/2017 16:43'!
CDTemplateTestPdfDocument
	| pdfdoc |
	pdfdoc := PDFDocument new.
	pdfdoc add: (PDFCompactDiscTemplate new format: PDFCompactDiscTemplate recommendedPageFormat).
	^ pdfdoc! !

!PDFDemos methodsFor: 'templates' stamp: 'AntoanHristov 2/17/2017 16:41'!
DVDTemplateTest: aStream	
	self DVDTemplateTestPdfDocument exportTo: aStream
! !

!PDFDemos methodsFor: 'templates' stamp: 'AntoanHristov 2/17/2017 16:40'!
DVDTemplateTestPdfDocument
	| pdfdoc |
	pdfdoc := PDFDocument new.
	pdfdoc add: (PDFDVDCoverTemplate new format: (PDFCompactDiscTemplate recommendedPageFormat)).
	^ pdfdoc! !

!PDFDemos methodsFor: 'text' stamp: 'AntoanHristov 2/17/2017 16:47'!
alignmentsTest: aStream
self alignmentsTestPdfDocument exportTo:aStream! !

!PDFDemos methodsFor: 'text' stamp: 'AntoanHristov 2/17/2017 16:45'!
alignmentsTestPdfDocument
	"a simple demonstration of Artefact"

	| pdfdoc myFont aPage |
	pdfdoc := PDFDocument new.
	myFont := PDFHelveticaFont new fontSize: 16 pt.
	aPage := PDFPage new.
	aPage
		add:
			(PDFFormattedTextElement new
				font: myFont;
				dimension: 210 mm @ 10 mm;
				from: 0 mm @ 0 mm;
				text: 'At left').

		aPage
		add:
			(PDFFormattedTextElement new
				font: myFont;
				dimension: 210 mm @ 10 mm;
				from: 0 mm @ 20 mm;
				text: 'Center';
				alignment: (PDFAlignment center)).
					aPage
		add:
			(PDFFormattedTextElement new
				font: myFont;
				dimension: 210 mm @ 10 mm;
				from: 0 mm @ 30 mm;
				text: 'At right';
				alignment: (PDFAlignment right)).
	pdfdoc add: aPage.
	^pdfdoc! !

!PDFDemos methodsFor: 'composite' stamp: 'AntoanHristov 2/17/2017 16:49'!
arrowTest: aStream
	
	self arrowTestPdfDocument exportTo: aStream! !

!PDFDemos methodsFor: 'composite' stamp: 'AntoanHristov 2/17/2017 16:49'!
arrowTestPdfDocument
	"drawing arrows"

	| pdfdoc aPage |
	pdfdoc := PDFDocument new.
	aPage := PDFPage new.
	aPage
		add:
			((PDFArrowElement from: 10 mm @ 10 mm to:  100 mm @ 30 mm)
				drawColor: (PDFColor r: 255 g: 0 b: 0)).
	aPage
		add:
			(PDFArrowElement from: 10 mm @ 20 mm to:  30 mm @ 30 mm).
	aPage
		add:
			((PDFArrowElement from: 120 mm @ 10 mm to:  120 mm @ 40 mm)
				drawColor: (PDFColor r: 0 g: 0 b: 255)).
	aPage
		add:
			((PDFArrowElement from: 125 mm @ 40 mm to:  140 mm @ 40 mm)
				drawColor: (PDFColor r: 0 g: 0 b: 255)).
	aPage
		add:
			((PDFArrowElement from: 125 mm @ 40 mm to:  100 mm @ 80 mm)
				drawColor: (PDFColor r: 0 g: 255 b: 0);
				dotted:
						(PDFDotted new
								length: 2 mm;
								space: 3 mm)).
	aPage
		add:
			((PDFArrowElement from: 40 mm @ 50 mm to:  80 mm @ 90 mm)
				drawColor: (PDFColor r: 192 g: 255 b: 0);
				thickness: 2 mm;
				roundCap: true).
	aPage
		add:
			((PDFDoubleArrowElement from: 10 mm @ 80 mm to:  100 mm @ 150 mm)
				drawColor: (PDFColor r: 0 g: 128 b: 0);
				dotted:
						(PDFDotted new
								length: 2 mm;
								space: 2 mm)).
	pdfdoc add: aPage.
	^pdfdoc! !

!PDFDemos methodsFor: 'draw' stamp: 'AntoanHristov 2/17/2017 16:50'!
bezierTest: aStream
	
	self bezierTestPdfDocument  exportTo: aStream! !

!PDFDemos methodsFor: 'draw' stamp: 'AntoanHristov 2/17/2017 16:50'!
bezierTestPdfDocument
	"drawing bezier curves"
	| pdfdoc aPage |
	pdfdoc := PDFDocument new.
	aPage := PDFPage new.	
			
	aPage
		add:
				((PDFBezierCurveElement
						from: 10 mm @ 50 mm
						points:
							{(0 mm @ 0 mm).
							(100 mm @ 20 mm).
							(150 mm @ 0 mm).
							(50 mm @ 50 mm)})
		thickness: 5 mm);
		add:
				((PDFBezierCurveElement
						from: 10 mm @ 70 mm
						points:
							{(0 mm @ 0 mm).
							(100 mm @ 20 mm).
							(150 mm @ 0 mm).
							(50 mm @ 50 mm)})
		thickness: 2 mm).
		
	pdfdoc add: aPage.
	^pdfdoc ! !

!PDFDemos methodsFor: 'experimental' stamp: 'AntoanHristov 2/17/2017 16:51'!
brochure: aStream
	"Artefact use an JPG file"
	self brochurePdfDocument  exportTo: aStream! !

!PDFDemos methodsFor: 'experimental' stamp: 'AntoanHristov 2/17/2017 16:51'!
brochurePdfDocument
	"Artefact use an JPG file"

	| pdfdoc aPage titleFont subtitleFont titleColor layout quoteFont pharoLogo |
	pharoLogo := ZnClient new
		url: 'http://forum.world.st/attachment/4659694/0/pharo6.jpeg';
		get.	"Downloading JPEG file from internet with Zinc"
	pdfdoc := PDFDocument new.
	titleColor := PDFColor r: 13 g: 100 b: 175.
	titleFont := PDFHelveticaFont new
		fontSize: 22 pt;
		bold: true.
	quoteFont := PDFHelveticaFont new
		fontSize: 8mm;
		bold: true;
		italic: true.
	subtitleFont := PDFHelveticaFont new
		fontSize: 16 pt;
		bold: true.
	aPage := PDFPage new.
	aPage
		add:
				(PDFTextElement new
						text: 'The Live Programming Environment';
						from: 60 mm @ 26 mm;
						dimension: 110 mm @ 80 mm;
						font: quoteFont);
		add:
				((PDFJpegElement fromStream: pharoLogo readStream)
						from: 15 mm @ 20 mm;
						dimension: 40 mm @ 40 mm).
	layout := PDFVerticalLayout
		on:
			{(PDFFormattedTextElement new
				font: titleFont;
				textColor: titleColor;
				text: 'About Pharo').
			(PDFFormattedTextElement new
				textColor: titleColor;
				font: subtitleFont;
				text: 'Mission').
			(PDFParagraphElement new
				dimension: 180 mm @ 35 mm;
				text:
						'Pharo''s goal is to deliver a clean, innovative, free open-source Smalltalk environment. By providing a stable and small core system, excellent developer tools, and maintained releases, Pharo is an attractive platform to build and deploy mission critical Smalltalk applications. Pharo is MIT licensed and is steered by a board of benevolent dictators. The board makes final decisions if no consensus can be reached within the community. Pharo fosters a healthy ecosystem of both private and commercial contributors who advance and maintain the core system and its external packages.').
			(PDFFormattedTextElement new
				textColor: titleColor;
				font: subtitleFont;
				text: 'Why Pharo?').
			(PDFParagraphElement new
				dimension: 180 mm @ 35 mm;
				text:
						'Pharo is a fork from the Squeak open-source Smalltalk. We decided to start Pharo because as active Squeakers, and responsible for Squeak 3.9, we felt the need to reconsider choices made. We want to create a better Smalltalk and be free to enhance it without fear of backwards compatibility to Squeak. Deciding to start Pharo was not easy because we invested a lot in Squeak (some of us wrote several books on Squeak and in particular Squeak By Example) and we like the Squeak community, but this is really important for us to open a new space. We want Pharo to be an excellent Smalltalk concerned with software engineering practices. We also want Pharo to be agile and be able to evolve. We hope you will like it and help make it better.').
			(PDFFormattedTextElement new
				textColor: titleColor;
				font: subtitleFont;
				text: 'A word about changes').
			(PDFParagraphElement new
				dimension: 180 mm @ 35 mm;
				text:
						'There is an important aspect behind Pharo: we want to make sure that Pharo is not a copy of the past but really a reinvention of Smalltalk. Now big-bang approaches rarely succeed. We will really favor evolutionary and incremental changes. We want to be able to experiment with important new features or libraries. For example, we need a new file library but that''s unlikely to happen in a day. Evolution means that we accept mistakes, we are not aiming for the next perfect solution in one big step -- even if we would love it. We will favor small incremental changes but a multitude of them. We will pay attention to your submissions to improve the system.')}.
	layout from: 15 mm @ 80 mm.
	layout spacing: 1 cm.
	aPage add: layout.
	pdfdoc add: aPage.
	^pdfdoc! !

!PDFDemos methodsFor: 'draw' stamp: 'AntoanHristov 2/17/2017 16:52'!
capLineTest: aStream
	"drawing simple lines with round cap"
self capLineTestPdfDocument  exportTo: aStream
! !

!PDFDemos methodsFor: 'draw' stamp: 'AntoanHristov 2/17/2017 16:52'!
capLineTestPdfDocument
	"drawing simple lines with round cap"

	| pdfdoc aPage |
	pdfdoc := PDFDocument new.
	aPage := PDFPage new.
	aPage
		add:
			((PDFLineElement 
				from: 20 mm @ 20 mm
				to: 100 mm @ 60 mm)
				thickness:  5 mm;
				drawColor: (PDFColor r: 100 g: 25 b: 100) ;
				roundCap: true).
	aPage
		add:
			((PDFLineElement 
				from: 30 mm @ 40 mm
				to: 110 mm @ 80 mm)
				drawColor: (PDFColor r: 240 g: 80 b: 100) ;
				thickness:  5 mm).
				
	pdfdoc add: aPage.

^pdfdoc
! !

!PDFDemos methodsFor: 'composite' stamp: 'AntoanHristov 2/17/2017 16:54'!
cellTest: aStream
	"Demonstration of PDFCellElement"
	
self cellTestPdfDocument exportTo: aStream
! !

!PDFDemos methodsFor: 'composite' stamp: 'AntoanHristov 2/17/2017 16:53'!
cellTestPdfDocument
	"Demonstration of PDFCellElement"
	
	| pdfdoc myTitleFont aPage |
	pdfdoc := PDFDocument new.	

	myTitleFont := (PDFTimesFont size: 24 pt) bold: true.
	
	aPage := PDFPage new.

	aPage add: (PDFCellElement new
		from: 10 mm @ 5 mm;
		dimension: 190 mm @ 10 mm;
		fillColor: (PDFColor new setGreyLevel: 224);
		text: 'Demonstration of PDFCellElement';
		font: myTitleFont;
		alignment: PDFAlignment center
	).
	
	"horizontal alignment"
	aPage add: (PDFCellElement new  
		from: 10 mm @ 20 mm;
		dimension: 50 mm @ 10 mm;
		text: 'alignment: left';
		alignment: PDFAlignment left
	).
	
	aPage add: (PDFCellElement new  
		from: 80 mm @ 20 mm;
		dimension: 50 mm @ 10 mm;
		text: 'alignment: center'
	 ).
	
	aPage add: (PDFCellElement new  
		from: 150 mm @ 20 mm;
		dimension: 50 mm @ 10 mm;
		text: 'alignment: right';
		alignment: PDFAlignment right
	).

	"vertical alignment"
	aPage add: (PDFCellElement new  
		from: 10 mm @ 40 mm;
		dimension: 50 mm @ 10 mm;
		text: 'vertical: top';
		alignment: PDFAlignment top left
	).
	
	aPage add: (PDFCellElement new  
		from: 80 mm @ 40 mm;
		dimension: 50 mm @ 10 mm;
		text: 'vertical: middle';
		alignment: PDFAlignment center middle
	).
	
	aPage add: (PDFCellElement new  
		from: 150 mm @ 40 mm;
		dimension: 50 mm @ 10 mm;
		text: 'vertical: bottom';
		alignment: PDFAlignment right bottom
	).

	"colors"
	aPage add: (PDFCellElement new  
		from: 10 mm @ 60 mm ;
		dimension: 50 mm @ 10 mm;
		textColor: (PDFColor r: 0 g: 0 b: 255);
		drawColor: (PDFColor r: 255 g: 0 b: 0);
		text: 'text: blue border: red';
		alignment: PDFAlignment center middle
	).
	
	aPage add: (PDFCellElement new  
		from: 80 mm @ 60 mm;
		dimension: 50 mm @ 10 mm;
		textColor: (PDFColor r: 0 g: 0 b: 255);
		fillColor: (PDFColor r: 0 g: 255 b: 0);
		text: 'background: green';
		alignment: PDFAlignment center middle
	).
	
	aPage add: (PDFCellElement new  
		from: 150 mm @ 60 mm;
		dimension: 50 mm @ 10 mm;
		textColor: (PDFColor new setGreyLevel: 255);
		fillColor: (PDFColor new setGreyLevel: 128);
		dotted: (PDFDotted new length: 1 mm; space: 1 mm);
		text: 'grey level & dotted border';
		thickness: 0.2 mm;
		alignment: PDFAlignment center middle
	).
	
	aPage add: (PDFCellElement new  
		from: 10 mm @ 80 mm;
		text: 'A cell without wh'
	).
	self flag: 'TODO Implement layout'.
	"aPage add: (PDFCellElement new  
		wh: 50 mm @ 10 mm;
		text: 'A cell without xy'
	).
	aPage add: (PDFCellElement new  
		wh: 50 mm @ 10 mm;
		text: 'linefeed: true';
		linefeed: true
	).
	aPage add: (PDFCellElement new  
		wh: 50 mm @ 10 mm;
		text: 'linefeed: false';
		linefeed: false
	).
	aPage add: (PDFCellElement new  
		wh: 50 mm @ 10 mm;
		text: 'end'
	)."

	pdfdoc add: aPage.
	
^pdfdoc 
! !

!PDFDemos methodsFor: 'draw' stamp: 'AntoanHristov 2/17/2017 16:55'!
circlesTest: aStream
	"drawing circles"
	self circlesTestPdfDocument exportTo: aStream! !

!PDFDemos methodsFor: 'draw' stamp: 'AntoanHristov 2/17/2017 16:55'!
circlesTestPdfDocument
	"drawing circles"
	| pdfdoc aPage |
	pdfdoc := PDFDocument new.
	aPage := PDFPage new.
	aPage add: (PDFCircleElement center: 50 mm @ 50 mm radius: 30 mm).
	aPage
		add:
			((PDFCircleElement from: 90 mm @ 20 mm to: 150 mm @ 180 mm)
				fillColor: (PDFColor r: 0 g: 255 b: 0);
				drawColor: (PDFColor r: 255 g: 0 b: 0)).
	pdfdoc add: aPage.
	^pdfdoc! !

!PDFDemos methodsFor: 'color' stamp: 'AntoanHristov 2/17/2017 16:56'!
colorTest: aStream
	"generate a sample document with colors"
self colorTestPdfDocument  exportTo: aStream
! !

!PDFDemos methodsFor: 'color' stamp: 'AntoanHristov 2/17/2017 16:56'!
colorTestPdfDocument
	"generate a sample document with colors"

	| pdfdoc aPage |
	pdfdoc := PDFDocument new.
	
	aPage := PDFPage new.
	aPage add: (PDFCellElement new 
		font: (PDFTimesFont new fontSize: 32pt);
		from: 10mm@10mm;
		dimension: 100 mm @ 20 mm; 
		text: 'Hello World!!';
		textColor: (PDFColor r: 255 g: 0 b: 0);
		fillColor: (PDFColor r: 0 g: 255 b: 0)
		).
	aPage add: (PDFRectElement new 
		from: 10 mm @ 50 mm;
		dimension: 50 mm @ 50 mm; 
		thickness: 5pt;
		drawColor: (PDFColor r: 0 g: 0 b: 255);
		fillColor: (PDFColor r: 0 g: 255 b: 0)
		).
		
	pdfdoc add: aPage.
	^pdfdoc
! !

!PDFDemos methodsFor: 'datatable' stamp: 'AntoanHristov 2/17/2017 16:58'!
datatableTest: aStream
	"generate a datatable"
	self datatableTestPdfDocument exportTo: aStream
! !

!PDFDemos methodsFor: 'datatable' stamp: 'AntoanHristov 2/17/2017 16:57'!
datatableTestPdfDocument
	"generate a datatable"

	| pdfdoc aPage |
		
	pdfdoc := PDFDocument new.
	pdfdoc setFormat: PDFA4Format new.
	pdfdoc metaData title: 'Users report'.
	pdfdoc styleSheet > #datatable > #even fillColor: (PDFColor r: 75 g: 75 b: 230).
	
	aPage := PDFPage new.
	aPage add: (PDFDataTableElement new
		data: #(
			#('Smith' 'Peter' 'peter.smith@mail.org')
			#('Jones' 'Mickael' 'mickael.jones@epr.com')
			#('washington' 'robert' 'robert.washington@blif.com')
		);
		from: 10 mm @ 10 mm;
		dimension: 190 mm @ 50 mm;
		customizationBlock: [ :cell :x :y :data | x even ifTrue: [cell style: #even] ]
	).

	aPage add: (PDFDataTableElement new
		data: #(
			#('Smith' 'Peter' 'peter.smith@mail.org')
			#('Jones' 'Mickael' 'mickael.jones@epr.com')
			#('washington' 'robert' 'robert.washington@blif.com')
		);
		textColor:(PDFColor r: 0 g: 0 b: 255);
		fillColor: (PDFColor new setGreyLevel: 230);
		font: (PDFTimesFont new fontSize: 6 pt);
		dotted: (PDFDotted new length: 0.2mm; space: 0.2mm);
		from: 10 mm @ 60 mm;
		dimension: 190 mm @ 50 mm
	).
	
	pdfdoc add: aPage.
	
																																																									^pdfdoc
! !

!PDFDemos methodsFor: 'datatable' stamp: 'AntoanHristov 2/17/2017 16:59'!
datatableWithCaptionsTest: aStream
	"generate a datatable with captions"
	self datatableTestPdfDocument  exportTo: aStream! !

!PDFDemos methodsFor: 'datatable' stamp: 'AntoanHristov 2/17/2017 16:59'!
datatableWithCaptionsTestPdfDocument
	"generate a datatable with captions"

	| pdfdoc aPage |
	pdfdoc := PDFDocument new.
	pdfdoc styleSheet > #dataTableWithColoredCaption > #caption
		fillColor: (PDFColor r: 158 g: 158 b: 79);
		drawColor: (PDFColor r: 158 g: 158 b: 79).
	pdfdoc styleSheet > #dataTableWithColoredCaption margin: 4 pt.
	pdfdoc styleSheet > #dataTableWithColoredCaption > #cell alignment: PDFAlignment right.
	pdfdoc setFormat: PDFA4Format new.
	pdfdoc metaData title: 'Users report'.
	aPage := PDFPage new.
	aPage
		add:
			(PDFDataTableWithColumnsCaptionElement new
				captions: #('Name' 'Surname' 'email');
				data:
						#(#('Smith' 'Peter' 'peter.smith@mail.org') #('Jones' 'Mickael' 'mickael.jones@epr.com') #('washington' 'robert' 'robert.washington@blif.com'));
				from: 10 mm @ 20 mm;
				dimension: 190 mm @ 60 mm;
				style: #dataTableWithColoredCaption;
				yourself).
	aPage
		add:
			(PDFDataTableWithRowsCaptionElement new
				captions: #('Name' 'Surname' 'email');
				data:
						#(#('Smith' 'Jones' 'washington') #('Peter' 'Mickael' 'robert') #('peter.smith@mail.org' 'mickael.jones@epr.com' 'robert.washington@blif.com'));
				from: 10 mm @ 90 mm;
				dimension: 190 mm @ 60 mm).
	pdfdoc add: aPage.
	^pdfdoc! !

!PDFDemos methodsFor: 'generate scripts/methods' stamp: 'AntoanHristov 3/3/2017 17:21'!
demosDefault
	"creating demos with a default date and time"
	| blackListed |
	blackListed := #( #imageJPGPdfDocument ).
	PDFDemos selectors
		do: [ :docString | 
			| doc |
			((docString endsWith: 'PdfDocument') and: [(blackListed includes: docString) not])
				ifTrue: [ doc := self perform: docString.
				 	doc exportTo:( docString , '.pdf') asFileReference writeStream ] ]
	"self CDTemplateTestPdfDocument exportTo: aStream"! !

!PDFDemos methodsFor: 'generate scripts/methods' stamp: 'AntoanHristov 3/13/2017 15:03'!
demosDefault: destination
	"creating demos with a default date and time"

	"destination : the folder destination"
	| blackListed folder |
	folder := destination asFileReference ensureCreateDirectory.
	blackListed := #(#imageJPGPdfDocument).
	PDFDemos selectors
		do: [ :docString | 
			| doc |
			((docString endsWith: 'PdfDocument')
				and: [ (blackListed includes: docString) not ])
				ifTrue: [ doc := self perform: docString.
					doc
						exportTo: (folder / docString , 'pdf') asFileReference writeStream ] ]
	"self CDTemplateTestPdfDocument exportTo: aStream"! !

!PDFDemos methodsFor: 'generate scripts/methods' stamp: 'AntoanHristov 3/10/2017 16:51'!
demosWithDate: aDateString AndTime: aTimeString
	"creating demos with a precise date and time "

	"ex aDateString - '02.17.2017' "

	"ex aTimeString - '5:19:45 pm' "

	| doc date time |
	date := Date fromString: aDateString.
	time := Time fromString: aTimeString.
	PDFDemos selectors
		do: [ :docString | 
			(docString endsWith: 'PdfDocument')
				ifTrue: [ doc := self perform: docString ].
			doc metaData date: date.
			doc metaData time: time.
			doc exportTo: docString , '.pdf' ]
	"self CDTemplateTestPdfDocument exportTo: aStream"! !

!PDFDemos methodsFor: 'generate scripts/methods' stamp: 'AntoanHristov 3/10/2017 16:34'!
demosWithDate: date AndTime: time destination: destinationFolder
	"creating demos with a precise date and time "

	| doc folder blackListed |
	blackListed := #(#imageJPGPdfDocument).
	folder := destinationFolder asFileReference ensureCreateDirectory.
	PDFDemos selectors
		do: [ :docString | 
			((docString endsWith: 'PdfDocument') and: [ (blackListed includes: docString) not ])
				ifTrue: [ doc := self perform: docString.
					doc metaData date: date.
					doc metaData time: time.
					doc exportTo: (folder / docString , 'pdf') asFileReference writeStream ] ]
	"self CDTemplateTestPdfDocument exportTo: aStream"! !

!PDFDemos methodsFor: 'display setup' stamp: 'AntoanHristov 2/17/2017 17:00'!
documentDisplayLayoutTest: aStream
	"Configuration of display layout: singlePage, twoPages or continuousPages"
self documentDisplayLayoutTestPdfDocument  exportTo: aStream
! !

!PDFDemos methodsFor: 'display setup' stamp: 'AntoanHristov 2/17/2017 17:00'!
documentDisplayLayoutTestPdfDocument
	"Configuration of display layout: singlePage, twoPages or continuousPages"

	| pdfdoc aPage1 aPage2 |
	pdfdoc := PDFDocument new twoPages.
	aPage1  := PDFPage new.
	aPage1
		add:
			(PDFTextElement new
				from: 10 mm @ 10 mm;
				text: 'First page').						
	pdfdoc add: aPage1.
	aPage2  := PDFPage new.
	aPage2
		add:
			(PDFTextElement new
				from: 10 mm @ 10 mm;
				text: 'Second page').						
	pdfdoc add: aPage2.

^pdfdoc! !

!PDFDemos methodsFor: 'display setup' stamp: 'AntoanHristov 2/17/2017 17:03'!
documentDisplayModeTest: aStream
	"Configuration of display mode: fullPage, fullWidth or real"

	
self documentDisplayModeTestPdfDocument  exportTo: aStream
! !

!PDFDemos methodsFor: 'display setup' stamp: 'AntoanHristov 2/17/2017 17:03'!
documentDisplayModeTestPdfDocument
	"Configuration of display mode: fullPage, fullWidth or real"

	| pdfdoc aPage1 aPage2 |
	pdfdoc := PDFDocument new fullPage.
	aPage1  := PDFPage new.
	aPage1
		add:
			(PDFTextElement new
				from: 10 mm @ 10 mm;
				text: 'First page').						
	pdfdoc add: aPage1.
	aPage2  := PDFPage new.
	aPage2
		add:
			(PDFTextElement new
				from: 10 mm @ 10 mm;
				text: 'Second page').						
	pdfdoc add: aPage2.

^pdfdoc 
! !

!PDFDemos methodsFor: 'display setup' stamp: 'AntoanHristov 2/17/2017 17:04'!
documentZoomTest: aStream
	"Configuration of zoom"

self documentZoomTestPdfDocument  exportTo: aStream
! !

!PDFDemos methodsFor: 'display setup' stamp: 'AntoanHristov 2/17/2017 17:04'!
documentZoomTestPdfDocument
	"Configuration of zoom"

	| pdfdoc aPage1 aPage2 |
	pdfdoc := PDFDocument new zoom: 400. "set the zoom at 400%"
	aPage1  := PDFPage new.
	aPage1
		add:
			(PDFTextElement new
				from: 10 mm @ 10 mm;
				text: 'First page').						
	pdfdoc add: aPage1.
	aPage2  := PDFPage new.
	aPage2
		add:
			(PDFTextElement new
				from: 10 mm @ 10 mm;
				text: 'Second page').						
	pdfdoc add: aPage2.

^pdfdoc 
! !

!PDFDemos methodsFor: 'color' stamp: 'AntoanHristov 2/17/2017 17:05'!
drawStyleSheetTest: aStream
	"generate a sample document with colors"

self drawStyleSheetTestPdfDocument  exportTo: aStream
! !

!PDFDemos methodsFor: 'color' stamp: 'AntoanHristov 2/17/2017 17:04'!
drawStyleSheetTestPdfDocument
	"generate a sample document with colors"

	| pdfdoc aPage |
	pdfdoc := PDFDocument new.
	
	aPage := PDFPage new.

	aPage add: (PDFRectElement new 
		from: 10 mm @ 50 mm;
		dimension: 50 mm @ 50 mm; 
		thickness: 5 mm;
		drawColor: (PDFColor r: 0 g: 0 b: 255);
		fillColor: (PDFColor r: 0 g: 255 b: 0)
		).
		
	aPage add: (PDFRectElement new 
		from: 50 mm @ 60 mm;
		dimension: 50 mm @ 50 mm).
		
	pdfdoc add: aPage.
	
^pdfdoc 
! !

!PDFDemos methodsFor: 'draw' stamp: 'AntoanHristov 2/17/2017 17:06'!
ellipsesTest: aStream
	"drawing circles"
	
	self ellipsesTestPdfDocument exportTo: aStream! !

!PDFDemos methodsFor: 'draw' stamp: 'AntoanHristov 2/17/2017 17:05'!
ellipsesTestPdfDocument
	"drawing circles"
	| pdfdoc aPage |
	pdfdoc := PDFDocument new.
	aPage := PDFPage new.
	aPage add: (PDFEllipseElement center: 50 mm @ 50 mm radius: 30 mm). "a circle"
	aPage
		add:
			((PDFEllipseElement from: 90 mm @ 20 mm to: 150 mm @ 180 mm)
				fillColor: (PDFColor r: 0 g: 255 b: 0);
				drawColor: (PDFColor r: 255 g: 0 b: 0)).
	pdfdoc add: aPage.
	^pdfdoc ! !

!PDFDemos methodsFor: 'text' stamp: 'AntoanHristov 2/17/2017 17:06'!
euroTest: aStream
	"a PDF document with the euro sign"
self euroTestPdfDocument  exportTo: aStream
! !

!PDFDemos methodsFor: 'text' stamp: 'AntoanHristov 2/17/2017 17:06'!
euroTestPdfDocument
	"a PDF document with the euro sign"

	| pdfdoc aPage theText|

       pdfdoc := PDFDocument new.

       aPage := PDFPage new.
	theText :=  ('Price: (24{1})toto' format: { (128 asCharacter) asString} ).
	
       aPage add: (PDFTextElement new from: 50 mm @ 10 mm; text: theText; font: (PDFTimesFont new)).
       aPage add: (PDFTextElement new from: 50 mm @ 20 mm; text: theText; font: (PDFCourierFont new)).
       aPage add: (PDFTextElement new from: 50 mm @ 30 mm; text: theText; font: (PDFHelveticaFont  new)).

	pdfdoc add: aPage.
	
^pdfdoc
! !

!PDFDemos methodsFor: 'color' stamp: 'AntoanHristov 2/17/2017 17:07'!
greyLevelTest: aStream
	"generate a sample document with grey levels"
	
self greyLevelTestPdfDocument  exportTo: aStream
! !

!PDFDemos methodsFor: 'color' stamp: 'AntoanHristov 2/17/2017 17:06'!
greyLevelTestPdfDocument
	"generate a sample document with grey levels"

	| pdfdoc aPage |
	pdfdoc := PDFDocument new.
	
	aPage := PDFPage new.

	aPage add: (PDFTextElement new 
		from: 10 mm @ 10 mm; 
		text: 'A grey level text'; 
		font: (PDFCourierFont new);
		textColor: (PDFColor new setGreyLevel: 128)
		).
		
	aPage add: (PDFRectElement new 
		from: 10 mm @ 20 mm;
		dimension: 50 mm @ 50 mm; 
		thickness: 5 pt;
		drawColor: (PDFColor new setGreyLevel: 196);
		fillColor: (PDFColor new setGreyLevel: 164)
		).
		
	pdfdoc add: aPage.
	
^pdfdoc ! !

!PDFDemos methodsFor: 'layout' stamp: 'AntoanHristov 2/17/2017 17:07'!
horizontalLayoutTest: aStream
	"self horizontalLayoutTest"

	"Demonstration of PDFCellElement"

self horizontalLayoutTestPdfDocument  exportTo: aStream
! !

!PDFDemos methodsFor: 'layout' stamp: 'AntoanHristov 2/17/2017 17:07'!
horizontalLayoutTestPdfDocument
	"self horizontalLayoutTest"

	"Demonstration of PDFCellElement"

	| pdfdoc myTitleFont aPage |
	pdfdoc := PDFDocument new.
	myTitleFont := PDFTimesFont new
		fontSize: 24 pt;
		bold: true.
	aPage := PDFPage new format: PDFA0Format new setLandscape ;
		add:
			(PDFHorizontalLayout new from: 10mm@10mm;
				add:
						(PDFCellElement new
								from: 10 mm @ 5 mm;
								dimension: 190 mm @ 10 mm;
								fillColor: (PDFColor new setGreyLevel: 224);
								text: 'Horizontal Layout';
								font: myTitleFont;
								alignment: PDFAlignment center);
				add:
						(PDFCellElement new
								from: 10 mm @ 20 mm;
								dimension: 50 mm @ 10 mm;
								text: 'alignment: left';
								alignment: PDFAlignment left);
				add:
						(PDFCellElement new
								from: 80 mm @ 20 mm;
								dimension: 50 mm @ 10 mm;
								text: 'alignment: center');
				add:
						(PDFCellElement new
								from: 150 mm @ 20 mm;
								dimension: 50 mm @ 10 mm;
								text: 'alignment: right';
								alignment: PDFAlignment right);
				add:
						(PDFCellElement new
								from: 10 mm @ 40 mm;
								dimension: 50 mm @ 10 mm;
								text: 'vertical: top';
								alignment: PDFAlignment left top);
				add:
						(PDFCellElement new
								from: 80 mm @ 40 mm;
								dimension: 50 mm @ 10 mm;
								text: 'vertical: middle';
								alignment: PDFAlignment center middle);
				add:
						(PDFCellElement new
								from: 150 mm @ 40 mm;
								dimension: 50 mm @ 10 mm;
								text: 'vertical: bottom';
								alignment: PDFAlignment right bottom);
				add:
						(PDFCellElement new
								from: 10 mm @ 60 mm;
								dimension: 50 mm @ 10 mm;
								textColor: (PDFColor r: 0 g: 0 b: 255);
								drawColor: (PDFColor r: 255 g: 0 b: 0);
								text: 'text: blue border: red';
								alignment: PDFAlignment center middle);
				add:
						(PDFCellElement new
								from: 80 mm @ 60 mm;
								dimension: 50 mm @ 10 mm;
								textColor: (PDFColor r: 0 g: 0 b: 255);
								fillColor: (PDFColor r: 0 g: 255 b: 0);
								text: 'background: green';
								alignment: PDFAlignment center middle);
				add:
						(PDFCellElement new
								from: 150 mm @ 60 mm;
								dimension: 50 mm @ 10 mm;
								textColor: (PDFColor new setGreyLevel: 255);
								fillColor: (PDFColor new setGreyLevel: 128);
								dotted:
										(PDFDotted new
												length: 1 mm;
												space: 1 mm);
								text: 'grey level & dotted border';
								thickness: 0.2 mm;
								alignment: PDFAlignment center middle);
				add:
						(PDFCellElement new
								from: 10 mm @ 80 mm;
								text: 'A cell without wh');
				add:
						(PDFCellElement new
								dimension: 50 mm @ 10 mm;
								text: 'A cell without xy')).
	pdfdoc add: aPage.
^pdfdoc 
! !

!PDFDemos methodsFor: 'image' stamp: 'AntoanHristov 2/17/2017 17:08'!
imageJPG: aStream
	"How to use a JPEG file with artefact"

self imageJPGPdfDocument  exportTo: aStream
! !

!PDFDemos methodsFor: 'image' stamp: 'AntoanHristov 2/17/2017 17:08'!
imageJPGPdfDocument
	"How to use a JPEG file with artefact"

	| pdfdoc aPage pharoByExampleLogo |
	pdfdoc := PDFDocument new.
	"Downloading JPEG file from internet with Zinc"
	pharoByExampleLogo := (ZnClient new
		url: 'http://pharobyexample.org/pictures/pbe-title.jpg';
		get).
	aPage := PDFPage new.
	aPage add: (PDFJpegElement from: 5 mm@0mm dimension: 160mm@90mm fromStream: pharoByExampleLogo readStream).
	aPage
		add:
			((PDFJpegElement
				fromStream: pharoByExampleLogo readStream)
				from: 40 mm @ 100 mm;
				dimension: 40 mm  @ 40 mm;
				rotation: 10
				).
	aPage
		add:
			((PDFJpegElement
				fromStream: pharoByExampleLogo readStream)
				from: 40 mm @ 180 mm;
				dimension: 40 mm  @ 40 mm;
				rotation: 30
				).
								
	pdfdoc add: aPage.
^pdfdoc ! !

!PDFDemos methodsFor: 'image' stamp: 'AntoanHristov 2/17/2017 17:09'!
imagePNG: aStream
	"How to use a PNG file with artefact"

self imagePNGPdfDocument  exportTo: aStream
! !

!PDFDemos methodsFor: 'image' stamp: 'AntoanHristov 2/17/2017 17:09'!
imagePNGPdfDocument
	"How to use a PNG file with artefact"

	| pdfdoc aPage pharoLogo |
	pdfdoc := PDFDocument new.
	"Downloading PNG file from internet with Zinc"
	pharoLogo := (ZnClient new
		url: 'http://pharo.org/files/pharo.png';
		get).
	aPage := PDFPage new.
	aPage add: (PDFPngElement from: 5 mm@0mm dimension: 160mm@90mm fromStream: pharoLogo readStream).
								
	pdfdoc add: aPage.
^pdfdoc
! !

!PDFDemos methodsFor: 'document' stamp: 'GuillaumeLarcheveque 5/31/2013 12:58'!
infosTest: aStream
	"generate a sample document with informations"

	| pdfdoc aPage |
	pdfdoc := PDFDocument new.
	
	pdfdoc metaData title: 'Document title'; 
		subject: 'subject of the document'; 
		author: 'The Pasta Team'; 
		keywords: 'cool rock best';
		creator: 'Artefact - Pharo'.
	
	aPage := PDFPage new.
	
	pdfdoc add: aPage.
		
pdfdoc exportTo: aStream
! !

!PDFDemos methodsFor: 'document' stamp: 'AntoanHristov 2/17/2017 17:09'!
infosTestPdfDocument
	"generate a sample document with informations"

	| pdfdoc aPage |
	pdfdoc := PDFDocument new.
	
	pdfdoc metaData title: 'Document title'; 
		subject: 'subject of the document'; 
		author: 'The Pasta Team'; 
		keywords: 'cool rock best';
		creator: 'Artefact - Pharo'.
	
	aPage := PDFPage new.
	
	pdfdoc add: aPage.
		
^pdfdoc
! !

!PDFDemos methodsFor: 'draw' stamp: 'AntoanHristov 2/17/2017 17:11'!
lineTest: aStream
	"drawing with simple lines around the page"

self lineTestPdfDocument  exportTo: aStream
! !

!PDFDemos methodsFor: 'draw' stamp: 'AntoanHristov 2/17/2017 17:10'!
lineTestPdfDocument
	"drawing with simple lines around the page"

	| pdfdoc aPage |
	pdfdoc := PDFDocument new.
	aPage := PDFPage new.
	
	aPage
		add:
			(PDFLineElement 
				from: 0 mm @ 0 mm
				to: 210 mm @ 0 mm).
	aPage
		add:
			(PDFLineElement 
				from: 0 mm @ 0 mm
				to: 0 mm @ 297 mm).
	aPage
		add:
			(PDFLineElement 
				from: 0 mm @ 297 mm
				to: 210 mm @ 297 mm).
	aPage
		add:
			(PDFLineElement 
				from: 0 mm @ 0 mm
				to: 210 mm @ 297 mm).

	aPage add: (PDFLineElement from: 210mm@297mm to: 210mm@0mm).
	aPage add: (PDFLineElement from: 210mm@0mm to: 0mm@297mm).

	pdfdoc add: aPage.
	pdfdoc styleSheet drawColor: (PDFColor r: 200 g: 25 b: 25).
^pdfdoc
! !

!PDFDemos methodsFor: 'color' stamp: 'AntoanHristov 2/17/2017 17:12'!
mosaiqueTest: aStream
	"generate a sample document with colored squares"

	self mosaiqueTestPdfDocument exportTo: aStream! !

!PDFDemos methodsFor: 'color' stamp: 'AntoanHristov 2/17/2017 17:11'!
mosaiqueTestPdfDocument
	"generate a sample document with colored squares"

	| tileSize plage pdfdoc aPage |
	pdfdoc := PDFDocument new.
	tileSize:= 5mm@5mm.
	plage := 0 to: 255.
	aPage := PDFPage new.
	pdfdoc add: aPage.
	0 to: (aPage format width convertTo: tileSize x unit) / tileSize x do: [ :x | 
		0 to: (aPage format height convertTo: tileSize y unit) / tileSize y do: [ :y | 
			aPage
				add:
					((PDFRectElement from: (x * tileSize x) @ (y * tileSize y) dimension: tileSize)
						fillColor: (PDFColor r: plage atRandom g: plage atRandom b: plage atRandom)) ] ].
	^pdfdoc ! !

!PDFDemos methodsFor: 'document' stamp: 'AntoanHristov 2/17/2017 17:12'!
multiOrientationsTest: aStream
	"Create a document with two pages and two different orientations"
	
self multiOrientationsTestPdfDocument  exportTo: aStream
! !

!PDFDemos methodsFor: 'document' stamp: 'AntoanHristov 2/17/2017 17:12'!
multiOrientationsTestPdfDocument
	"Create a document with two pages and two different orientations"
	
	| pdfdoc myBigFont firstPage secondPage myLandscapeFormat |
	pdfdoc := PDFDocument new.	

	myLandscapeFormat := PDFA3Format new setLandscape.
	
	myBigFont := PDFTimesFont new fontSize: 16 pt.
	
	firstPage := PDFPage new.	
	firstPage add: (PDFCellElement new 
		from: 10mm@10mm;
		font: myBigFont; 
		dimension: 40 mm @ 10 mm; 
		text: 'Page 1').
	
	secondPage := PDFPage new format: myLandscapeFormat.
	
	secondPage add: (PDFCellElement new 
		from: 10mm@10mm;
		font: myBigFont; 
		dimension: 40 mm @ 10 mm; 
		text: 'Page en A3').	
			
	pdfdoc add: firstPage.
	pdfdoc add: secondPage.

^pdfdoc 
! !

!PDFDemos methodsFor: 'style' stamp: 'AntoanHristov 2/17/2017 17:23'!
multiStyleArrowsTest: aStream
	"drawing arrows with differents styles"

	self multiStyleArrowsTestPdfDocument exportTo: aStream! !

!PDFDemos methodsFor: 'style' stamp: 'AntoanHristov 2/17/2017 17:12'!
multiStyleArrowsTestPdfDocument
	"drawing arrows with differents styles"
	
	| pdfdoc aPage |
	pdfdoc := PDFDocument new.	
	pdfdoc styleSheet > #redArrow at: #drawColor put: (PDFColor r: 243 g: 24 b: 24).
	pdfdoc styleSheet	at: #drawColor put: (PDFColor r: 24 g: 24 b: 180).
	pdfdoc styleSheet > #greenArrow at: #drawColor put: (PDFColor r: 24 g: 180 b: 24).
	pdfdoc styleSheet > #greenArrow > #head at: #drawColor put: (PDFColor r: 255 g: 0 b: 0).
	aPage := PDFPage new.
	
	aPage add: ((PDFArrowElement 
		from: 10 mm @ 10 mm
		to: 100 mm @30 mm)
		style: #redArrow
	).

	aPage add: (PDFArrowElement 
		from: 10 mm @20 mm
		to: 30 mm @30 mm
	).

	aPage add: ((PDFArrowElement 
		from: 10 mm @ 15 mm
		to: 70 mm @30 mm)
		style: #greenArrow
	).
			
	pdfdoc add: aPage.
	
^pdfdoc 
! !

!PDFDemos methodsFor: 'cool' stamp: 'AntoanHristov 2/17/2017 17:14'!
oneLineTest: aStream
	self oneLineTestPdfDocument exportTo: aStream
! !

!PDFDemos methodsFor: 'cool' stamp: 'AntoanHristov 2/17/2017 17:14'!
oneLineTestPdfDocument
	^PDFDocument new add: (PDFPage new add: (PDFTextElement new text: 'Hello'; from: 10mm@10mm))

! !

!PDFDemos methodsFor: 'composite' stamp: 'AntoanHristov 2/17/2017 17:15'!
paragraphTest: aStream
self paragraphTestPdfDocument exportTo: aStream
! !

!PDFDemos methodsFor: 'composite' stamp: 'AntoanHristov 2/17/2017 17:15'!
paragraphTestPdfDocument
	"Use of paragraphs"
	
	| pdfdoc aPage |
	pdfdoc := PDFDocument new.	
	
	aPage := PDFPage new.

	aPage add: (PDFParagraphElement new 
		from: 90 mm @ 40 mm;
		dimension: 100 mm @ 20 mm; 
		text: '1 Emensis itaque difficultatibus multis et nive obrutis callibus plurimis ubi prope Rauracum ventum est ad supercilia fluminis Rheni, resistente multitudine Alamanna pontem suspendere navium conpage Romani vi nimia vetabantur ritu grandinis undique convolantibus telis, et cum id inpossibile videretur, imperator cogitationibus magnis attonitus, quid capesseret ambigebat.').

	aPage add: (PDFParagraphElement new 
		from: 20 mm @ 40 mm;
		dimension: 60 mm @ 60 mm; 
		text: '2 Quam ob rem ut ii qui superiores sunt submittere se debent in amicitia, sic quodam modo inferiores extollere. Sunt enim quidam qui molestas amicitias faciunt, cum ipsi se contemni putant; quod non fere contingit nisi iis qui etiam contemnendos se arbitrantur; qui hac opinione non modo verbis sed etiam opere levandi sunt.').

	aPage add: (PDFParagraphElement new 
		from: 100 mm @ 80 mm;
		dimension: 60 mm @ 70 mm; 
		text: '3 Denique Antiochensis ordinis vertices sub uno elogio iussit occidi ideo efferatus, quod ei celebrari vilitatem intempestivam urgenti, cum inpenderet inopia, gravius rationabili responderunt; et perissent ad unum ni comes orientis tunc Honoratus fixa constantia restitisset.';
		alignment: PDFAlignment center).
		
	aPage add: (PDFParagraphElement new 
		from: 10 mm @ 120 mm;
		dimension: 60 mm @ 80 mm; 
		text: '4 Igitur per multiplices dilatata fortunas cum ambigerentur quaedam, non nulla levius actitata constaret, post multorum clades Apollinares ambo pater et filius in exilium acti cum ad locum Crateras nomine pervenissent, villam scilicet suam quae ab Antiochia vicensimo et quarto disiungitur lapide, ut mandatum est, fractis cruribus occiduntur.';
		alignment: PDFAlignment right
		).
		
	pdfdoc add: aPage.	
^ pdfdoc
! !

!PDFDemos methodsFor: 'composite' stamp: 'OlivierAuverlot 5/31/2013 08:13'!
paragraphWithSpacingTest: aStream
	"Use of paragraphs"
	
	| pdfdoc aPage |
	pdfdoc := PDFDocument new.	
	
	aPage := PDFPage new.

	aPage add: (PDFParagraphElement new 
		from: 90 mm @ 40 mm;
		dimension: 100 mm @ 20 mm; 
		text: '1 Emensis itaque difficultatibus multis et nive obrutis callibus plurimis ubi prope Rauracum ventum est ad supercilia fluminis Rheni, resistente multitudine Alamanna pontem suspendere navium conpage Romani vi nimia vetabantur ritu grandinis undique convolantibus telis, et cum id inpossibile videretur, imperator cogitationibus magnis attonitus, quid capesseret ambigebat.').

	aPage add: (PDFParagraphElement new 
		from: 20 mm @ 40 mm;
		dimension: 60 mm @ 60 mm; 
		spacing: 0.5mm;
		text: '2 Quam ob rem ut ii qui superiores sunt submittere se debent in amicitia, sic quodam modo inferiores extollere. Sunt enim quidam qui molestas amicitias faciunt, cum ipsi se contemni putant; quod non fere contingit nisi iis qui etiam contemnendos se arbitrantur; qui hac opinione non modo verbis sed etiam opere levandi sunt.').

	aPage add: (PDFParagraphElement new 
		from: 100 mm @ 80 mm;
		dimension: 60 mm @ 70 mm; 
		spacing: 1mm;
		text: '3 Denique Antiochensis ordinis vertices sub uno elogio iussit occidi ideo efferatus, quod ei celebrari vilitatem intempestivam urgenti, cum inpenderet inopia, gravius rationabili responderunt; et perissent ad unum ni comes orientis tunc Honoratus fixa constantia restitisset.';
		alignment: PDFAlignment center).
		
	aPage add: (PDFParagraphElement new 
		from: 10 mm @ 120 mm;
		dimension: 60 mm @ 80 mm; 
		spacing: 3 mm;
		text: '4 Igitur per multiplices dilatata fortunas cum ambigerentur quaedam, non nulla levius actitata constaret, post multorum clades Apollinares ambo pater et filius in exilium acti cum ad locum Crateras nomine pervenissent, villam scilicet suam quae ab Antiochia vicensimo et quarto disiungitur lapide, ut mandatum est, fractis cruribus occiduntur.';
		alignment: PDFAlignment right
		).
		
	pdfdoc add: aPage.
	
pdfdoc exportTo: aStream
! !

!PDFDemos methodsFor: 'draw' stamp: 'AntoanHristov 2/17/2017 17:16'!
polygonsTest: aStream
self polygonsTestPdfDocument exportTo: aStream! !

!PDFDemos methodsFor: 'draw' stamp: 'AntoanHristov 2/17/2017 17:16'!
polygonsTestPdfDocument
	"drawing polygons"
	| pdfdoc aPage |
	pdfdoc := PDFDocument new.
	aPage := PDFPage new.
	aPage
		add:
			((PDFPolygonElement
				from: 10 mm @ 10 mm
				points:
					{(0 mm @ 0 mm).
					(60 mm @ 20 mm).
					(50 mm @ 40 mm).
					(30 mm @ 50 mm).
					(15 mm @ 45 mm)}) drawColor: (PDFColor r: 0 g: 0 b: 255)).
	aPage
		add:
			((PDFPolygonElement
				from: 10 mm @ 65 mm
				points:
					{(0 mm @ 0 mm).
					(60 mm @ 60 mm).
					(50 mm @ 100 mm).
					(30 mm @ 110 mm).
					(15 mm @ 105 mm)})
				drawColor: (PDFColor r: 0 g: 0 b: 255);
				fillColor: (PDFColor r: 255 g: 0 b: 0);
				thickness: 5 mm;
				roundCap: true).
	pdfdoc add: aPage.
	^pdfdoc! !

!PDFDemos methodsFor: 'draw' stamp: 'AntoanHristov 2/17/2017 17:17'!
rectsTest: aStream
	self rectsTestPdfDocument exportTo: aStream
! !

!PDFDemos methodsFor: 'draw' stamp: 'AntoanHristov 2/17/2017 17:16'!
rectsTestPdfDocument
	"intersecting rects"
	
	| pdfdoc aPage |
	pdfdoc := PDFDocument new.	
	
	aPage := PDFPage new.
	
	aPage add: (PDFRectElement from: 0 mm @ 0 mm dimension: 210 mm @ 297 mm).
	
	aPage add: (PDFRectElement new
		from: 10 mm @ 10 mm;
		dimension: 100 mm @ 30 mm).
	aPage add: (PDFRectElement new
		from: 15 mm @ 15 mm;
		dimension: 100 mm @ 30 mm;
		fillColor: (PDFColor r: 142 g: 24 b: 78)
		).		
	aPage add: (PDFRectElement new
		from: 20 mm @ 20 mm;
		dimension: 100 mm @ 30 mm;
		drawColor: (PDFColor r: 0 g: 255 b: 0) 
		).
	pdfdoc add: aPage.

^pdfdoc
! !

!PDFDemos methodsFor: 'experimental' stamp: 'AntoanHristov 2/17/2017 17:18'!
rotationTest: aStream
self rotationTestPdfDocument exportTo: aStream
! !

!PDFDemos methodsFor: 'experimental' stamp: 'AntoanHristov 2/17/2017 17:17'!
rotationTestPdfDocument
	"PDFDemos rotationTest"

	| pdfdoc aPage  |
	pdfdoc := PDFDocument new compression: false.
	
	aPage := PDFPage new.
	aPage add: (PDFTextElement from: 10 mm @ 10 mm text: 'A very simple text').
		
	0 to: 35do: [ :a |
		aPage add: (PDFTextElement new from: 50 mm @ 50 mm; text: ('Rotated text with ' , (a * 10) asString); rotation: (a * 10)).
	].
		
	aPage add: (PDFTextElement from: 10 mm @ 50 mm text: 'A very simple text').
	pdfdoc  add: aPage.
	^pdfdoc
! !

!PDFDemos methodsFor: 'text' stamp: 'AntoanHristov 2/17/2017 17:18'!
textTest: aStream
self textTestPdfDocument exportTo: aStream
! !

!PDFDemos methodsFor: 'text' stamp: 'AntoanHristov 2/17/2017 17:18'!
textTestPdfDocument
	"PDFDemos textTest"

	| pdfdoc myFont aPage myFontInMilliMeters |
	pdfdoc := PDFDocument new.
	myFont := PDFTimesFont size: 24 pt.
	myFontInMilliMeters := PDFTimesFont size: 5 mm.
	aPage := PDFPage new.
	aPage
		add:
				(PDFTextElement from: 10 mm @ 10 mm text: 'A very simple text');
		add:
				(PDFTextElement new
						font: myFont;
						from: 10 mm @ 30 mm;
						text: 'A very simple text with specified font');
		add:
				(PDFTextElement new
						textColor: (PDFColor r: 255 g: 0 b: 0);
						from: 10 mm @ 50 mm;
						text: 'A very simple text with specified color');
		add:
				(PDFTextElement new
						textColor: (PDFColor r: 0 g: 0 b: 255);
						font: myFont;
						from: 10 mm @ 70 mm;
						text: 'A very simple text with specified color and font');
		add:
				(PDFTextElement new
						textColor: (PDFColor r: 0 g: 128 b: 255);
						font: myFontInMilliMeters;
						from: 10 mm @ 85 mm;
						text: 'A text with font expressed in mm (5)');
		add:
				(PDFLineElement 
						from: 10 mm @ 85 mm
						to: 160 mm @ 85 mm);
		add:
				(PDFLineElement 
						from: 10 mm @ 90 mm
						to: 160 mm @ 90 mm).
	pdfdoc add: aPage.
^pdfdoc
! !

!PDFDemos methodsFor: 'draw' stamp: 'AntoanHristov 2/17/2017 17:19'!
thicknessTest: aStream
	self thicknessTestPdfDocument exportTo: aStream
! !

!PDFDemos methodsFor: 'draw' stamp: 'AntoanHristov 2/17/2017 17:19'!
thicknessTestPdfDocument
	"generate a sample document for testing the draw objects"

	| pdfdoc aPage xy1 xy2 |

	pdfdoc := PDFDocument new.	
	aPage := PDFPage new.
	xy1 := 10 mm @ 20 mm.
	xy2 := 100 mm@ 20 mm.
	
	1 to: 5 do: [ :i |
		aPage add: ((PDFLineElement from: xy1 to: xy2) thickness: i mm).
		xy1 := (xy1 x) @ (xy1 y + 10 mm).
		xy2 := (xy2 x) @ (xy2 y + 10 mm).
	].	
	
	aPage add: ((PDFRectElement  
		from: 50 mm @ 80 mm
		dimension: 50 mm @ 50 mm)
		thickness:  5 mm
		).
	
	pdfdoc add: aPage.
		
	^pdfdoc
! !

!PDFDemos methodsFor: 'draw' stamp: 'AntoanHristov 2/17/2017 17:20'!
twoColoredRectsOpacityTest: aStream
	self twoColoredRectsOpacityTestPdfDocument exportTo: aStream
! !

!PDFDemos methodsFor: 'draw' stamp: 'AntoanHristov 2/17/2017 17:20'!
twoColoredRectsOpacityTestPdfDocument
	"intersecting rects with opacity control"
	
	| pdfdoc aPage |
	pdfdoc := PDFDocument new uncompressed.	
	
	aPage := PDFPage new.
	
	aPage add: (PDFRectElement new
		from: 10 mm @ 10 mm;
		dimension: 100 mm @ 30 mm;
		fillColor: (PDFColor r: 142 g: 24 b: 78);
		drawColor: (PDFColor r: 255 g: 0 b: 0);
		opacity: (PDFOpacityNormal alpha: 0.6)).
	aPage add: ((PDFTextElement from: 10 mm @ 10 mm text: 'A very simple text') opacity:  (PDFOpacityNormal alpha: 0.5)).
	aPage add: (PDFRectElement new
		from: 15 mm @ 15 mm;
		dimension: 100 mm @30 mm;
		fillColor: (PDFColor r: 24 g: 57 b: 205);
		drawColor: (PDFColor r: 0 g: 255 b: 0);
		opacity: (PDFOpacityColorBurn alpha: 0.3)).		
	pdfdoc add: aPage.
	
^pdfdoc
! !

!PDFDemos methodsFor: 'draw' stamp: 'AntoanHristov 2/17/2017 17:21'!
twoColoredRectsTest: aStream
self twoColoredRectsTestPdfDocument exportTo: aStream
! !

!PDFDemos methodsFor: 'draw' stamp: 'AntoanHristov 2/17/2017 17:21'!
twoColoredRectsTestPdfDocument
	"intersecting rects"
	
	| pdfdoc aPage |
	pdfdoc := PDFDocument new.	
	
	aPage := PDFPage new.
	
	aPage add: (PDFRectElement new
		from: 10 mm @ 10 mm;
		dimension: 100 mm @ 30 mm;
		fillColor: (PDFColor r: 142 g: 24 b: 78);
		drawColor: (PDFColor r: 255 g: 0 b: 0)).
	aPage add: (PDFRectElement new
		from: 15 mm @ 15 mm;
		dimension: 100 mm @30 mm;
		fillColor: (PDFColor r: 24 g: 57 b: 205);
		drawColor: (PDFColor r: 0 g: 255 b: 0)).		
	pdfdoc add: aPage.
	
^pdfdoc
! !

!PDFDemos methodsFor: 'layout' stamp: 'AntoanHristov 2/17/2017 17:22'!
verticalLayoutTest: aStream
self verticalLayoutTestPdfDocument exportTo: aStream
! !

!PDFDemos methodsFor: 'layout' stamp: 'AntoanHristov 2/17/2017 17:21'!
verticalLayoutTestPdfDocument
	"self verticalLayoutTest"

	| pdfdoc myTitleFont aPage |
	pdfdoc := PDFDocument new.
	myTitleFont := PDFTimesFont new
		fontSize: 24 pt;
		bold: true.
	aPage := PDFPage new
		add:
			(PDFVerticalLayout new from: 10mm@10mm;
				add:
						(PDFCellElement new
								from: 10 mm @ 5 mm;
								dimension: 190 mm @ 10 mm;
								fillColor: (PDFColor new setGreyLevel: 224);
								text: 'Demonstration of PDFCellStyle';
								font: myTitleFont;
								alignment: PDFAlignment center);
				add:
						(PDFCellElement new
								from: 10 mm @ 20 mm;
								dimension: 50 mm @ 10 mm;
								text: 'alignment: left';
								alignment: PDFAlignment left);
				add:
						(PDFCellElement new
								from: 80 mm @ 20 mm;
								dimension: 50 mm @ 10 mm;
								text: 'alignment: center');
				add:
						(PDFCellElement new
								from: 150 mm @ 20 mm;
								dimension: 50 mm @ 10 mm;
								text: 'alignment: right';
								alignment: PDFAlignment right);
				add:
						(PDFCellElement new
								from: 10 mm @ 40 mm;
								dimension: 50 mm @ 10 mm;
								text: 'vertical: top';
								alignment: PDFAlignment left top);
				add:
						(PDFCellElement new
								from: 80 mm @ 40 mm;
								dimension: 50 mm @ 10 mm;
								text: 'vertical: middle';
								alignment: PDFAlignment center middle);
				add:
						(PDFCellElement new
								from: 150 mm @ 40 mm;
								dimension: 50 mm @ 10 mm;
								text: 'vertical: bottom';
								alignment: PDFAlignment right bottom);
				add:
						(PDFCellElement new
								from: 10 mm @ 60 mm;
								dimension: 50 mm @ 10 mm;
								textColor: (PDFColor r: 0 g: 0 b: 255);
								drawColor: (PDFColor r: 255 g: 0 b: 0);
								text: 'text: blue border: red';
								alignment: PDFAlignment center middle);
				add:
						(PDFCellElement new
								from: 80 mm @ 60 mm;
								dimension: 50 mm @ 10 mm;
								textColor: (PDFColor r: 0 g: 0 b: 255);
								fillColor: (PDFColor r: 0 g: 255 b: 0);
								text: 'background: green';
								alignment: PDFAlignment center middle);
				add:
						(PDFCellElement new
								from: 150 mm @ 60 mm;
								dimension: 50 mm @ 10 mm;
								textColor: (PDFColor new setGreyLevel: 255);
								fillColor: (PDFColor new setGreyLevel: 128);
								dotted:
										(PDFDotted new
												length: 1 mm;
												space: 1 mm);
								text: 'grey level & dotted border';
								thickness: 0.2 mm;
								alignment: PDFAlignment center middle);
				add:
						(PDFCellElement new
								from: 10 mm @ 80 mm;
								text: 'A cell without wh');
				add:
						(PDFCellElement new
								dimension: 50 mm @ 10 mm;
								text: 'A cell without xy')).
	pdfdoc add: aPage.
^pdfdoc
! !

!PDFDemos methodsFor: 'misc' stamp: 'AntoanHristov 2/17/2017 17:23'!
widthTest: aStream
self widthTestPdfDocument exportTo: aStream
! !

!PDFDemos methodsFor: 'misc' stamp: 'AntoanHristov 2/17/2017 17:22'!
widthTestPdfDocument
	"generate a sample document for testing the width of fonts"

	| pdfdoc aPage myFont myOtherFont width text |

	pdfdoc := PDFDocument new.	
			
	myFont := PDFTimesFont new fontSize: 16 pt.
	text := 'Hello World !!'.

	aPage := PDFPage new.
	
	width := myFont getStringWidth: text.
	aPage add: (PDFCellElement new from: 5mm@10mm; font: myFont; dimension: width@10mm; text: text).

	myOtherFont := PDFTimesFont new.
	myOtherFont fontSize: (myOtherFont getIdealFontSizeForTheString: text width: 10mm).
	aPage add: (PDFCellElement new from: 5mm@20mm; font: myOtherFont; dimension: 10mm@2mm; text: text).
	
	pdfdoc add: aPage.
		
	^pdfdoc
! !
